# #C240610A. 先增后减

## 题目描述

Jerry 又给了 Tom 一个长为 $N$ 的正整数序列 $A_i$，Tom 可以进行若干次操作，每次可以选择一个位置 $i$，满足 $1 \leq i \leq N-1$，将 $A_i$ 的值和 $A_{i+1}$ 的值进行交换。

设经过这若干次操作后的序列为 $B_i$，那么需要存在一个整数 $k \in [1,N]$，满足：

- 区间 $[1,k]$ 构成的子序列 $[B_1,B_2,\cdots,B_k]$ 是一个非严格单调递增的序列，即相邻两项允许相等，但是左边元素不能大于右边元素。
- 区间 $[k,N]$ 构成的子序列 $[B_k,B_{k+1},\cdots,B_N]$ 是一个非严格单调递减的序列，即相邻两项允许相等，但是左边元素不能小于右边元素。

Tom 想知道至少需要对序列进行多少次上述操作后，这个要求才能得以满足，他把这个问题交给了你来解决。

## 输入格式

第一行一个整数 $N$，表示序列长度。

第二行 $n$ 个整数表示 $A_1,A_2,\cdots,A_n$。

## 输出格式

输出一个整数，表示答案，即最少的操作次数。

## 样例

### 输入数据 1

```
7
3 1 4 1 5 9 2
```

### 输出数据 1

```
3
```

### 输入数据 2

```
9
10 4 6 3 15 9 1 1 12
```

### 输出数据 2

```
8
```

### 输入数据 3

```
8
9 9 8 8 7 7 6 6
```

### 输出数据 3

```
0
```

**【样例4】**

见下发样例 inde4.in/inde4.ans 。

## 数据规模与约定

- 对于 $20\%$ 的数据，满足 $n \leq 10$。
- 对于 $50\%$ 的数据，满足 $n \leq 5000$。
- 对于 $100\%$ 的数据，满足 $1 \leq n \leq 10^5$，$1 \leq a_i \leq 10^5$。

# #C240610B. 美食节

## 题目描述

在 OI 国，所有城市排成了一个序列，从左往右分布是编号为 $1, 2, \cdots$ 的城市。

青蛙今天在 OI 国旅游，一开始他在编号为 $x$ 的城市。

OI 国准备举办 $n$ 次美食节，第 $i$ 次的美食节在编号区间 $[l_i, r_i]$ 内的城市上举办。在每次美食节开始之前，青蛙可以在 OI 国中从当前他在的城市旅游到另一个城市，从编号为 $a$ 的城市移动到编号为 $b$ 的城市会让他花费 $|a-b|$ 元钱。

如果一次美食节举办时，青蛙不在美食节举办的范围内，此时我们假设青蛙当前所在城市到美食节举办范围内城市的最短距离为 $k$，则青蛙会花费 $k$ 元，请人帮他从最近的美食节举办的城市买美食。

为了让青蛙省钱，你需要求出所有的美食节举办结束后，青蛙最少的花费。

## 输入格式

第一行两个正整数 $n, x$。

接下来 $n$ 行，每行两个正整数 $l_i, r_i$。

## 输出格式

输出一个整数，表示答案。

## 样例

### 输入数据 1

```
5 4
2 7
9 16
8 10
9 17
1 6
```

### 输出数据 1

```
8
```

**【样例2】**

见下发文件 festival2.in/festival2.ans。

## 数据规模与约定

- 对于 $20\%$ 的数据，满足 $n, x, l_i, r_i \leq 10$。
- 对于 $50\%$ 的数据，满足 $n \leq 2000$。
- 对于 $100\%$ 的数据，满足 $1 \leq n \leq 5 \times 10^5$，$0 \leq x, l, r \leq 10^9$。

# C240610C. 天竺葵

## 题目描述

我们称一个长度为 $k$ 的序列 $c$ 是好的，当且仅当对任意正整数 $i$ 在 $[1,k-1]$ 中，满足 $c_{i+1} > b_i \times c_i$，其中 $b$ 序列在下文描述。

小 L 现在给你两个序列 $a, b$，你需要从 $a$ 序列中找出一个最长的子序列 $c$，使得 $c$ 是好的。

输出这个最长的好的子序列的长度即可。

## 输入格式

第一行一个数 $n$，表示序列的长度。

接下来一行 $n$ 个数表示序列 $a$。

接下来一行 $n$ 个数表示序列 $b$。

## 输出格式

一行一个数，表示最长的好的子序列的长度。

## 样例

### 输入数据 1

```
4
1 2 3 10
2 3 4 5
```

### 输出数据 1

```
3
```

【样例1解释】

${1,3,10}$ 是好的序列，因为 $3>2\times1, 10>3\times3$。

## 数据规模与约定

- 对于 $25\%$ 的数据，满足 $n \leq 100$。
- 对于另外 $25\%$ 的数据，满足 $n \leq 1000$。
- 对于另外 $5\%$ 的数据，满足 $b_i = i+1$。
- 对于另外 $10\%$ 的数据，满足 $b_i > 1$。
- 对于另外 $15\%$ 的数据，满足 $b_i = 1$。
- 对于 $100\%$ 的数据，满足 $1 \leq n \leq 10^6$，$1 \leq a_i \leq 10^{12}$，$1 \leq b_i \leq 10^6$。

# C240610D. 风信子

## 题目描述

Tom 给你一个长为 $n$ 的序列 $a$。

定义一个合法二元组 $(i,j)$ 需要满足 $i, j$ 为整数，且 $i \leq j$。如果 $i > j$，则 $(i,j)$ 不构成合法二元组。

定义一个合法二元组 $(i,j)$ 的分数为 $a_i - a_j$。

定义一个合法二元组 $(i,j)$ 在区间 $[l,r]$ 内，当且仅当 $l \leq i, j \leq r$。

有 $m$ 次操作：

- `1 l r x`：表示将序列中第 $l$ 个位置到第 $r$ 个位置都加上 $x$。
- `2 l r k`：表示询问选出 $k$ 个不同的合法二元组，每个合法二元组都在区间 $[l,r]$ 内，这些合法二元组的分数和最高是多少。

即选出一些合法二元组 $(i_1,j_1)$，$(i_2,j_2)$，$\cdots$，$(i_k,j_k)$，满足这些选出的合法二元组两两不同，且分数和尽可能大。

两个合法二元组 $(i_1,j_1)$ 与 $(i_2,j_2)$ 不同，当且仅当 $i_1 \neq i_2$ 或 $j_1 \neq j_2$。

## 输入格式

第一行两个整数 $n, m$。

接下来一行 $n$ 个整数，表示最初的序列 $a$。

接下来 $m$ 行，每行一个操作，形如：

```
1 l r x
2 l r k
```

意义如题面所示。

## 输出格式

对每个第二种操作，分别输出一行一个数，表示满足询问条件的最大的合法二元组分数和。

## 样例

### 输入数据 1

```
6 5
1 1 4 5 1 4
2 4 6 3
2 1 6 2
1 1 4 -2
1 4 6 1
2 2 5 5
```

### 输出数据 1

```
5
7
2
```

【样例1解释】

对于第一次询问，选择的合法二元组为 $(4,4)$，$(4,5)$，$(4,6)$，分数为 $(5-5)+(5-1)+(5-4)=5$。

对于第二次询问，选择的合法二元组为 $(3,5)$，$(4,5)$，分数为 $(4-1)+(5-1)=7$。

对于第三次询问，此时序列变成了 $[-1,-1,2,4,2,5]$，选择的合法二元组为 $(2,2)$，$(3,3)$，$(3,5)$，$(4,4)$，$(4,5)$，分数为 $((-1)-(-1))+(2-2)+(2-2)+(4-4)+(4-2)=2$。

样例的选择方案不唯一，样例解释只是给出了一种可能的方案。

## 数据规模与约定

- 对于 $10\%$ 的数据，满足 $n, m \leq 100$。
- 对于另外 $25\%$ 的数据，满足 $n, m \leq 1000$，所有询问的 $k$ 的和不超过 $2000$。
- 对于另外 $15\%$ 的数据，满足 $n, m \leq 1000$。
- 对于另外 $15\%$ 的数据，满足 $k = 1$。
- 对于另外 $15\%$ 的数据，满足没有 $1$ 操作。
- 对于 $100\%$ 的数据，满足 $1 \leq n, m \leq 10^5$，$1 \leq l \leq r \leq n$，所有询问的 $k$ 的和不超过 $3 \times 10^5$，$-10^6 \leq a_i, x \leq 10^6$。

数据保证区间 $[l,r]$ 中一定可以找到 $k$ 个合法二元组。